#include <bits/stdc++.h>

using namespace std;

int test;
long long minN, maxN;
long long minA, maxA;
long long minB, maxB;

bool getParams(int argc, char *argv[]) {
	if (argc == 1)
		return false;
	test = atol(argv[1]);
	minN = atoll(argv[2]);
	maxN = atoll(argv[3]);
	minA = atoll(argv[4]);
	maxA = atoll(argv[5]);
	minB = atoll(argv[6]);
	maxB = atoll(argv[7]);
	return true;
}

void readParams() {
	cin >> test;
	cin >> minN >> maxN;
	cin >> minA >> maxA;
	cin >> minB >> maxB;
}

void writeTest(vector<pair<int, int>>& v) {
	cout << v.size() << endl;
	for (int i = 0; i < v.size(); ++i) {
		cout << v[i].first << " " << v[i].second << endl;
	}
}

long long randNumber(long long l, long long r) {
	long long x = ((rand() << 16LL) + rand()) % 1000000000;
	long long y = ((rand() << 16LL) + rand()) % 1000000000;
	long long z = ((rand() << 16LL) + rand()) % 1000000000;
	long long res = (x * y + z) % (r - l + 1) + l;
	return res;
}

int main(int argc, char *argv[]) {
	if (!getParams(argc, argv))
		readParams();

	srand(test + minN + maxN + minA + maxA + minB + maxB);

	int n = randNumber(minN, maxN);
	vector<pair<int, int>> v(n);
	long long sum = 0;
	for (int i = 0; i < n; ++i) {
		v[i].first = randNumber(minA, maxA);
		v[i].second = randNumber(minB, maxB);
		sum += v[i].first * v[i].second;
	}

	if ((rand() & 1) && sum % v.size()) {
		vector<int> I;
		for (int i = 0; i < v.size(); ++i) {
			I.push_back(i);
		}
		random_shuffle(I.begin(), I.end());

		for (auto idx : I) {
			int res = sum - v[idx].first * v[idx].second;
			res = v.size() - (res % v.size());

			vector<int> d;
			for (int i = 1; i * i <= res; ++i) {
				if (res % i == 0 && i <= 1000 && res / i <= 1000) {
					d.push_back(i);
					d.push_back(res / i);
				}
			}

			if (d.size() == 0) {
				continue;
			}

			int jdx = randNumber(0, d.size() - 1);
			v[idx].first = d[jdx];
			v[idx].second = res / d[jdx];
			break;
		}
	}

	writeTest(v);
    return 0;
}
